   (DEFUN HAMILTCYCLE (LAMBDA (GRAPH)
   ; GRAPH -     ᬥ           ;
   ; : ⮭ 横   ᯨ᪠ 設, ;
   ; NIL - ᫨ ⮭ 横         ;
      (COND ( (NULL GRAPH) NIL )
            (  T  (COND ( (NULL (CDR GRAPH))
                              (LIST (CAAR GRAPH)))
                        (  T  (HC GRAPH (CAAR GRAPH)
                                  (LIST (CAAR GRAPH))
                                  (CDAR GRAPH)
                              )
                        )
                  )
            )
      )
   ))
   ; ---------------------------------------- ;
   (DEFUN HC (LAMBDA (GRAPH START VISITED SONS)
   ; START   - ࢠ 設            ;
   ; VISITED - ᯨ᮪ ன 設       ;
   ; SONS    - ᥤ ᬠਢ 設 ;
      (COND ( (NULL SONS) NIL )
            (  T  (COND ( (AND (MEMBER START SONS)
                               (EQ (LENGTH GRAPH)
                                   (LENGTH VISITED))
                          )
                             (REVERSE VISITED)
                        )
                        ( T (COND
                              ( (MEMBER (CAR SONS) VISITED)
                                  (HC GRAPH START VISITED
                                             (CDR SONS)) )
                              (  T  (OR (HC GRAPH START
                                            (CONS
                                              (CAR SONS)
                                              VISITED)
                                            (NEIGHBOUR3
                                              (CAR SONS)
                                              GRAPH)
                                        )
                                        (HC
                                           GRAPH START VISITED
                                           (CDR SONS))) )) )
                  )
            )
      )
   ))
   ; ------------------------------- ;
   (DEFUN NEIGHBOUR3 (LAMBDA (X GRAPH)
      (COND ( (NULL (ASSOC X GRAPH)) NIL )
            (  T  (CDR (ASSOC X GRAPH)) )
      )
   ))
(RDS)